<?php

/************************************************************************************/
/* SiteMail v1.1 for PHP-Nuke 5.6.0                                                 */
/* ================================                                                 */
/*                                                                                  */
/* SiteMail                                                                         */
/* v1.1                                                                             */
/* 02-08-2002                                                                       */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@mat.allfreetemplates.com)           */
/* http://mat.allfreetemplates.com                                                  */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/

require_once( "mainfile.php" );
global $prefix, $user_prefix, $dbi;

if ( !is_admin( $admin ) )
{
   die ( "Sorry you are not an administrator, You can not install this module" );
}

/******************************************************************************/
/* FUNCTION: InstallSiteMail()                                                */
/* Prepare for installation                                                   */
/******************************************************************************/
function InstallSiteMail()
{
   global $admin, $user_prefix, $dbi;

   $pagetitle = "SiteMail v1.1 == Install/Upgrade";
   include("header.php");
   OpenTable();
   echo "<form action=\"install_sitemail.php\" method=\"post\">\n";
   echo "<center>This script will install the tables required for SiteMail v1.1 in your Database in case v1.0 is not installed.<br>\n";
   echo "<center>When v1.0 is already installed, it will upgrade your database tables to v1.1.<br>\n";
   echo "<br>\n";
   echo "Click \"Install/Upgrade\" below to begin.<br>\n";
   echo "<br>\n";
   echo "<input type=\"hidden\" name=\"op\" value=\"CreateTables\">";
   echo "<input type=\"submit\" value=\"Install/Upgrade\"></center>";
   echo "</form>";
   CloseTable();
   echo "<br>";
   OpenTable();
   echo "<center>$pagetitle by <a href=\"http://mat.allfreetemplates.com\">Maty Scripts</a></center>";
   CloseTable();
   include("footer.php");
}

/******************************************************************************/
/* FUNCTION: CreateTables()                                                   */
/* Create the required tables in the Nuke database                            */
/******************************************************************************/
function CreateTables()
{
   global $user_prefix, $dbi;

   $pagetitle = "SiteMail v1.1 == Install/Upgrade";
   include("header.php");

   OpenTable();
   echo "Installation Status!<br>\n";
   echo "<br>\n";

   // Read colour scheme Configuration Settings. When they do NOT EXIST, v1.0 is NOT INSTALLED
   // When they exist, SiteMail v1.0 is installed and an upgrade will be carried out !
   $result = sql_query( "select BGMailColor, BGTitleColor, BGCellColor1, BGCellColor2, TitleFontColor, CellFontColor from ".$user_prefix."_sitemail_cnf where uid='1'", $dbi );
   if ( !$result )
   {
       echo "SiteMail v1.0 is not installed on your Site. A normal installation wil be carried out for SiteMail v1.1!<br>\n";
       echo "<br>\n";
       NewInstallSiteMail();
   }   
   else
   {
       echo "SiteMail v1.0 is already installed on your site. An UPGRADE of the database tables to SiteMail v1.1 wil be carried out!<br>\n";
       echo "<br>\n";       
       UpgradeSiteMail();
   }

   CloseTable();
   include("footer.php");
}
   
/******************************************************************************/
/* FUNCTION: NewInstallSiteMail()                                             */
/* Create the required tables in the Nuke database for SiteMail               */
/******************************************************************************/
function NewInstallSiteMail()
{
   global $user_prefix, $dbi;
   
   $pagetitle = "SiteMail v1.1 == Clean Installation";

   OpenTable();
   echo "Installation Status!<br>\n";
   echo "<br>\n";

   // Drop the 4 new SiteEmail tables
   $result = sql_query( "DROP TABLE $user_prefix"._sitemail_cnf."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."._sitemail_cnf table <b>did not exist</b>.<br>\n"; }   
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>deleted</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "DROP TABLE $user_prefix"._sitemail_email."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."._sitemail_email table <b>did not exist</b>.<br>\n"; }   
   else { echo "- ".$user_prefix."_sitemail_email table <b>deleted</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "DROP TABLE $user_prefix"._sitemail_sentbox."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."._sitemail_sentbox table <b>did not exist</b>.<br>\n"; }   
   else { echo "- ".$user_prefix."_sitemail_sentbox table <b>deleted</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "DROP TABLE $user_prefix"._sitemail_users."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."._sitemail_users table <b>did not exist</b>.<br>\n"; }   
   else { echo "- ".$user_prefix."_sitemail_users table <b>deleted</b>.<br>\n"; }
   echo "<br>\n";

   // Create the 4 new required SiteMail tables
   $result = sql_query( "CREATE TABLE $user_prefix"._sitemail_cnf."
   ( uid int(11) NOT NULL auto_increment,
     BGMailColor varchar(7) NOT NULL default '#CCD4DB',
     BGTitleColor varchar(7) NOT NULL default '#2181B0',
     BGCellColor1 varchar(7) NOT NULL default '#EFEFEF',
     BGCellColor2 varchar(7) NOT NULL default '#DEE3E7',
     TitleFontColor varchar(7) NOT NULL default '#FFA34F',
     CellFontColor varchar(7) NOT NULL default '#000000',
     max_store int(5) NOT NULL default '10',
     max_emails int(5) NOT NULL default '25',
     StatsUsersPP int(5) NOT NULL default '10',
     pop3 tinyint(1) unsigned NOT NULL default '1',
     Copyright varchar(15) NOT NULL default 'Maty Scripts',
     SMVersion varchar(15) NOT NULL default 'SiteMail v1.1',  
     PRIMARY KEY  (uid)
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_cnf table <b>creation error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>created</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "INSERT INTO $user_prefix"._sitemail_cnf." VALUES
   ( '1', '#CCD4DB', '#2181B0', '#EFEFEF', '#DEE3E7', '#FFA34F', '#000000', '10', '25', '10', '1', 'Maty Scripts', 'SiteMail v1.1' )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_cnf table <b>Insertion error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>Data inserted</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "CREATE TABLE $user_prefix"._sitemail_email."
   ( uid int(11) NOT NULL auto_increment,
     uname varchar(25) NOT NULL default '',
     email varchar(255) NOT NULL default '',
     first varchar(50) NOT NULL default '',
     last varchar(50) NOT NULL default '',
     url varchar(255) default NULL,
     street varchar(50) default NULL,
     city varchar(50) default NULL,
     zip varchar(10) default NULL,
     country varchar(50) default NULL,
     notes text,
     PRIMARY KEY  (uid)
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_email table <b>creation error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_email table <b>created</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "CREATE TABLE $user_prefix"._sitemail_sentbox."
   ( uid int(11) NOT NULL auto_increment,
     uname varchar(25) NOT NULL default '',
     from_email varchar(255) NOT NULL default '',
     to_email text NOT NULL,
     cc_email text NOT NULL,
     bcc_email text NOT NULL,
     subject_email varchar(255) NOT NULL default '',
     message_email text NOT NULL,
     timestamp varchar(20) NOT NULL default '',
     PRIMARY KEY  (uid)
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_sentbox table <b>creation error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_sentbox table <b>created</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "CREATE TABLE $user_prefix"._sitemail_users."
   ( uid int(11) NOT NULL auto_increment,
     uname varchar(25) NOT NULL default '',
     name varchar(60) NOT NULL default '',
     email varchar(255) NOT NULL default '',
     url varchar(255) NOT NULL default '',
     user_from varchar(100) NOT NULL default '',
     mail_counter int(11) NOT NULL default '0',
     mail_format tinyint(4) NOT NULL default '1',
     mail_save tinyint(4) NOT NULL default '1',
     mail_priority tinyint(1) NOT NULL default '3',
     pop3_server varchar(50) NOT NULL default '',
     pop3_port tinyint(4) NOT NULL default '110',
     pop3_counter int(11) NOT NULL default '0',
     body_text tinyint(1) unsigned NOT NULL default '0',  
     PRIMARY KEY  (uid)
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_users table <b>creation error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_users table <b>created</b>.<br>\n"; }
   echo "<br>\n";

   // Optimize SiteMail Tables   
   OptimizeSiteMailTables();

   echo "Installation has completed!<br>\n";
   echo "<br>\n";
   echo "Delete this install file now!\n";
   CloseTable();
   echo "<br>";
   OpenTable();
   echo "<center>$pagetitle by <a href=\"http://mat.allfreetemplates.com\">Maty Scripts</a></center>";
   CloseTable();
}

/******************************************************************************/
/* FUNCTION: UpgradeSiteMail()                                                */
/* Upgrade SiteMail Tables from v1.0 to v1.1                                  */
/******************************************************************************/
function UpgradeSiteMail()
{
   global $user_prefix, $dbi;
   
   $pagetitle = "SiteMail v1.1 == Upgrade from SiteMail version 1.0";

   OpenTable();
   echo "Installation Status!<br>\n";
   echo "<br>\n";

   // add 4 new fields in nuke_sitemail_cnf table
   $result = sql_query( "ALTER TABLE $user_prefix"._sitemail_cnf." ADD
   ( 
      StatsUsersPP int(5) NOT NULL default '10',     
      pop3 tinyint(1) unsigned NOT NULL default '1',
      Copyright varchar(15) NOT NULL default 'Maty Scripts',
      SMVersion varchar(15) NOT NULL default 'SiteMail v1.1'
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_cnf table <b>Upgrade Error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>Table Upgraded</b>.<br>\n"; }
   echo "<br>\n";

   // add default values to these 4 new fields   
   $result = sql_query( "UPDATE $user_prefix"._sitemail_cnf." SET
   StatsUsersPP='10', pop3='1', Copyright='Maty Scripts', SMVersion='SiteMail v1.1' WHERE uid='1'", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_cnf table <b>Insertion error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>Data inserted</b>.<br>\n"; }
   echo "<br>\n";

   // add 6 new fields in nuke_sitemail_email table
   $result = sql_query( "ALTER TABLE $user_prefix"._sitemail_email." ADD
   ( 
     url varchar(255) default NULL,
     street varchar(50) default NULL,
     city varchar(50) default NULL,
     zip varchar(10) default NULL,
     country varchar(50) default NULL,
     notes text
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_email table <b>Upgrade Error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_email table <b>Table Upgraded</b>.<br>\n"; }
   echo "<br>\n";
 
   // add 4 new fields in nuke_sitemail_users table
   $result = sql_query( "ALTER TABLE $user_prefix"._sitemail_users." ADD
   ( 
      pop3_server varchar(50) NOT NULL default '',
      pop3_port tinyint(4) NOT NULL default '110',
      pop3_counter int(11) NOT NULL default '0',
      body_text tinyint(1) unsigned NOT NULL default '0'  
   )", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_users table <b>Upgrade Error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_users table <b>Table Upgraded</b>.<br>\n"; }
   echo "<br>\n";
    
   // Check user_from field. Due to differences in Forums, the extension of the location
   // can be .gif or NO .gif !. So, remove the .gif extension if it exists and than add it again !
   $result = sql_query( "SELECT uid, user_from FROM $user_prefix"._sitemail_users."", $dbi );
   while( list ( $uid, $user_from ) = sql_fetch_row( $result, $dbi ) )
   {
      $user_from = basename( $user_from, ".gif" ) . ".gif";   
      $result1 = sql_query( "UPDATE $user_prefix"._sitemail_users." SET user_from='$user_from' WHERE uid=$uid", $dbi );
   }

   // Optimize SiteMail Tables   
   OptimizeSiteMailTables();

   echo "Upgrade has completed!<br>\n";
   echo "<br>\n";
   echo "Delete this install file now!\n";
   CloseTable();

   echo "<br>";
   OpenTable();
   echo "<center>$pagetitle by <a href=\"http://mat.allfreetemplates.com\">Maty Scripts</a></center>";
   CloseTable();
}

/******************************************************************************/
/* FUNCTION: UpgradeSiteMail()                                                */
/* Optimize the 4 SiteMail Tables                                             */
/******************************************************************************/
function OptimizeSiteMailTables()
{
   global $user_prefix, $dbi;
   
   // Optimize SiteMail Tables
   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_cnf."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_cnf table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_cnf table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_email."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_email table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_email table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_sentbox."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_sentbox table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_sentbox table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";

   $result = sql_query( "OPTIMIZE TABLE $user_prefix"._sitemail_users."", $dbi );
   if ( !$result ) { echo "- ".$user_prefix."_sitemail_users table <b>optimization error</b>.<br>\n"; }
   else { echo "- ".$user_prefix."_sitemail_users table <b>optimized</b>.<br>\n"; }
   echo "<br>\n";
}

/***************************************************/
/****************** INSTALL START ******************/
/***************************************************/
switch( $op ) 
{
   case "CreateTables":
      CreateTables();
   break;

   case "NewInstallSiteMail":
      NewInstallSiteMail();
   break;

   case "UpgradeSiteMail":
      UpgradeSiteMail();
   break;

   case "OptimizeSiteMailTables":
      OptimizeSiteMailTables();
   break;

   default:
      InstallSiteMail();
   break;
}

?>
