<?php

/************************************************************************************/
/* PHP-NUKE: Web Portal System                                                      */
/* ===========================                                                      */
/*                                                                                  */
/* Copyright (c) 2001 by Francisco Burzi (fburzi@ncc.org.ve)                        */
/* http://phpnuke.org                                                               */
/*                                                                                  */
/* SiteMail                                                                         */
/* v1.1                                                                             */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@mat.allfreetemplates.com)           */
/* http://mat.allfreetemplates.com                                                  */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/

if (!eregi("modules.php", $PHP_SELF)) {
	die ("You can't access this file directly...");
}
require_once("mainfile.php");
$module_name = basename( dirname( __FILE__ ) );

if( isset( $newlang ) ) {
   include( "modules/$module_name/language/lang-$newlang.php" );
   $language = $newlang;
}
elseif ( isset( $lang ) ) {
   include( "modules/$module_name/language/lang-$lang.php" );
   $language = $lang;
}
else {
   include( "modules/$module_name/language/lang-$language.php" );
}

/******************************************************************************/
/* FUNCTION: CheckData()                                                      */
/* Check the entered data entered in the mail form                            */
/******************************************************************************/
function CheckData( $from_email, $to_email, $cc_email, $bcc_email, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $username )
{
   include( "header.php" );   
   
   OpenTable();
   
   $DataOK = 1;
   if ( $from_email == "" )
   {
      $from_err = "<p><center><font color=red>"._MSM_ERRORFROM."</font></center><br>";
      $DataOK = 0;
   }
   if ( $to_email[0] == "" )
   {
      $to_err = "<p><center><font color=red>"._MSM_ERRORTO."</font></center><br>";
      $DataOK = 0;
   }
   if ( $subject_email == "" )
   {
      $subject_err = "<p><center><font color=red>"._MSM_ERRORSUBJECT."</font></center><br>";
      $DataOK = 0;
   }
   if ( $message_email == "" )
   {
      $message_err = "<p><center><font color=red>"._MSM_ERRORMESSAGE."</font></center><br>";
      $DataOK = 0;
   }

   if ( $DataOK == 0 )
   {
      echo "<h2 align=center><font color=red><b>"._MSM_ERRORDATA."</font></h2></b><br>\n";
      echo "$from_err";
      echo "$to_err";
      echo "$subject_err";
      echo "$message_err";
      echo "<center>[ <a href=\"javascript:history.go( -1 )\">"._MSM_GOBACK."</a> ]</center>";
      CloseTable();
   }
   else
   {
      // It's ok to send the E-mail, all fields are filled out
      // Extract now the selected E-mail addresses

      // Get the TO Email addresses and Generate TO Line
      $to = "";
      for( $i=0;$i<count($to_email);$i++ )
      {
         $to_email[$i] = substr( $to_email[$i], 0, strpos( $to_email[$i], ">" ) - 1 );
         $to .= $to_email[$i].",";
      }
      $to = rtrim( $to, "," );

      // Get the CC Email addresses and generate CC Line
      $cc = "";
      if( $cc_email[0] != "" )
      {
         for( $i=0;$i<count($cc_email);$i++ )
         {
            $cc_email[$i] = substr( $cc_email[$i], 0, strpos( $cc_email[$i], ">" ) - 1 );
            $cc .= $cc_email[$i].",";
         }
         $cc_exists = 1;
         $cc = rtrim( $cc, "," );
      }
      else
      {
         $cc_exists = 0;
      }
      
      // Get the BCC Email addresses and generate BCC Line
      $bcc = "";
      if( $bcc_email[0] != "" )
      {
         for( $i=0;$i<count($bcc_email);$i++ )
         {
            $bcc_email[$i] = substr( $bcc_email[$i], 0, strpos( $bcc_email[$i], ">" ) - 1 );
            $bcc .= $bcc_email[$i].",";
         }
         $bcc_exists = 1;
         $bcc = rtrim( $bcc, "," );
      }
      else
      {
         $bcc_exists = 0;
      }

      SendEmail( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $cc_exists, $bcc_exists, $username );
   }
   
   CloseTable();
   include( "footer.php" );
}

/******************************************************************************/
/* FUNCTION: SendEmail()                                                      */
/* Send the E-mail                                                            */
/******************************************************************************/
function SendEmail( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $cc_exists, $bcc_exists, $username )
{
   global $dbi, $user_prefix, $module_name;
  
   //$header .= "X-Sender: <mail@server.com>\n";
   //$header .= "Return-Path: <mail@server.com>\n";
   $header = "From: $from_email\r\n";
   $header .= "Reply-to: $from_email\r\n";
   if( $cc_exists == 1 ) { $header .= "Cc: $cc\r\n"; }
   if( $bcc_exists == 1 ) { $header .= "Bcc: $bcc\r\n"; }
   $header .= "X-Priority: $mail_priority\r\n";
   $header .= "X-Mailer: PHP".phpversion()."\r\n";
   
   if( $mail_format == 0 )
   { 
      $header .= "MIME-Version: 1.0\r\n";
      $header .= "Content-type: text/html; charset=iso-8859-1\r\n";
      $message = "<br>".$message_email;
   }
   else
   {
      $message = "\r\n".$message_email;
   }

   if( @mail( $to, $subject_email, $message, $header ) == 1 )
   {
      // Mail sent succesfully
      UpdateUserSettings( $username, $mail_format, $mail_save, $mail_priority );
      echo "\n<h3 align=center><font color=black><b>"._MSM_MAILSEND."</b></font></h3>\n";
      
      // Store E-mail if set to Mail_Save = Yes
      if( $mail_save == 1 )
      { 
         // Get Max_Store parameter from Admin Config Settings
         $result = sql_query( "select max_store from ".$user_prefix."_sitemail_cnf where uid='1'", $dbi );
         list( $max_store ) = sql_fetch_row( $result, $dbi );
         // Determine how many E-mails already present in SentBox
         $result = sql_query( "select * from ".$user_prefix."_sitemail_sentbox where uname='$username'", $dbi );
         $instore = sql_num_rows( $result );
         
	 if( $instore < $max_store )
	 { 	      
            StoreInSentBox( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $username );
         }
         else
         {
            echo "\n<h4 align=center><font color=blue><br><b>"._MSM_WARNINGSENTNOTSTORED."</b></font></h4>\n";          		 
         }
      }
   }
   else
   {
      // Mail could not be sent
      echo "\n<h3 align=center><font color=red><b>"._MSM_ERRORMAILNOTSEND."</b></font></h3>\n";
   }

   echo "<p><center>[ <a href=\"modules.php?name=$module_name\">"._MSM_GOBACK."</a> ]</center>";   
}

/******************************************************************************/
/* FUNCTION: UpdateUserSettings                                               */
/* Update for user the amount of sent E-mails, mail_format and mail_save      */
/******************************************************************************/
function UpdateUserSettings( $username, $mail_format, $mail_save, $mail_priority )
{
   global $user, $dbi, $user_prefix;
    
   $result = sql_query( "select mail_counter from ".$user_prefix."_sitemail_users where uname='$username'", $dbi );
   list( $mail_counter ) = sql_fetch_row( $result, $dbi );
   $mail_counter += 1;
   $query="update ".$user_prefix."_sitemail_users set mail_counter='$mail_counter', mail_format='$mail_format', mail_save='$mail_save', mail_priority='$mail_priority' where uname='$username'";
   $result = sql_query( $query, $dbi );
   if ( !$result )
   {
       echo ""._MSM_ERRORUSERUPDATE."";
   }
}

/******************************************************************************/
/* FUNCTION: StoreInSentBox                                                   */
/* Write E-mail to SentBox                                                    */
/******************************************************************************/
function StoreInSentBox( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $username )
{
   global $user, $dbi, $user_prefix;

   $result = sql_query( "select max(uid) as latest_uid from $user_prefix"._sitemail_sentbox."", $dbi );
   list( $latest_uid ) = sql_fetch_array( $result, $dbi );
   if ( $latest_uid == "-1")
   {
      $latest_uid = 1;
   }
   else
   {
      $latest_uid += 1;
   }

   $timestamp = date("d-m-Y G-i");
   $result = sql_query( "insert into $user_prefix"._sitemail_sentbox." ( uid, uname, from_email, to_email, cc_email, bcc_email, subject_email, message_email, timestamp ) values (  '$latest_uid', '$username', '$from_email', '$to', '$cc', '$bcc', '$subject_email', '$message_email', '$timestamp' )", $dbi );
   if ( !$result )
   {
       echo ""._MSM_ERRORSENTSTORAGE."";
   }      
}

/***************************************************/
/****************** PROGRAM START ******************/
/***************************************************/
switch ( $op )
{
    case "CheckData":
       CheckData( $from_email, $to_email, $cc_email, $bcc_email, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $username );
    break;

    case "SendEmail":
       SendEmail( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $cc_exists, $bcc_exists, $username );
    break;

    case "UpdateUserSettings":
       UpdateUserSettings( $username, $mail_format, $mail_save, $mail_priority );
    break;

    case "StoreInSentBox":
       StoreInSentBox( $from_email, $to, $cc, $bcc, $subject_email, $message_email, $username );
    break;

    default:
	CheckData( $from_email, $to_email, $cc_email, $bcc_email, $subject_email, $message_email, $mail_format, $mail_save, $mail_priority, $username );
}


?>